/*
 * Copyright 
 *   2005 axYus - www.axyus.com
 *   2005 C.Marchand - christophe.marchand@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.cp.xemelios.plugins;

import fr.gouv.finances.cp.xemelios.common.config.ListeResultatModel;
import fr.gouv.finances.cp.xemelios.data.DataResultSet;

/**
 * Defines contract to make search plugins.
 * An implementation must provide a constructor with no parameters
 * @author chm
 */
public abstract class SearchPlugin extends XemeliosPlugin {
    private ListeResultatModel lrm;


    /* (non-Javadoc)
     * @see org.jdesktop.swingworker.SwingWorker#doInBackground()
     */
    @Override
    public abstract DataResultSet doInBackground() throws Exception;

    public abstract void computeParameters() throws Exception;

    public void startSearch() throws Exception {
        computeParameters();
        execute();
    }

    @Override
    public int getPluginType() {
        return XemeliosPlugin.TYPE_SEARCH;
    }

    public DataResultSet getResultSet() throws Exception {
        return (DataResultSet) get();
    }
    
    public void setListeResultat(ListeResultatModel lrm) { this.lrm = lrm; }
    public ListeResultatModel getListeResultat() { return lrm; }

    /*
     * Build the SQL condition from MySqlDataLayer(getOperators) and value val
     */
    public String convertOpString(String op, String val) {
        if ("starts-with".equals(op)) {
            return " like '" + val + "%' ";
        } else if ("contains".equals(op)) {
            return " like '%" + val + "%' ";
        } else if ("xem:ends-with".equals(op)) {
            return " like '%" + val + "' ";
        } else if ("xem:StringEquals".equals(op)) {
            return " like '" + val + "' ";
        } else if ("xem:StringDiffers".equals(op)) {
            return " <> '" + val + "' ";
        } else if ("xem:StringIsNull".equals(op)) {
            return " = '' ";
        } else if ("xem:StringIsNotNull".equals(op)) {
            return " <> '' ";
        } else {
            return "";
        }
    }
}
